{#-#####################################################################
 # Jinja2 template for /etc/network/interfaces
 #======================================================================
 # Macros responsible for the generation of inet6 stanzas
 ####################################################################-#}
{#======================================================================
 # Generate auto stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating an 'inet6 auto' stanza.
 #===================================================================-#}
{%- macro generate_auto_stanza(interface, indexes) -%}
  {%- set TAB = "\t" -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#- Set shortcut variables -#}
  {%- set rtadv   = interface['inet6']['ndp']['rtadv'] -%}
  {%- set slaac   = interface['inet6']['slaac'] -%}
  {%- set llocal  = interface['inet6']['slaac']['link_local'] -%}
  {%- set rfc4041 = autoconf['privacy'] -%}
  {%- set dhcp6   = interface['inet6']['dhcp'] -%}

  {#- Fetch config settings -#}
  {%- set slaac_is_enabled        = slaac['enabled'] -%}
  {%- set rtadv_is_enabled        = rtadv['enabled'] -%}
  {%- set rtadv_is_forced         = rtadv['forced'] -%}
  {%- set ll_autoconf_attempts    = ll['attempts'] -%}
  {%- set ll_autoconf_interval    = ll['interval'] -%}
  {%- set rfc4041_is_enabled      = rfc4041['enabled'] -%}
  {%- set rfc4041_is_preferred    = rfc4041['preferred'] -%}
  {%- set dhcp6_is_enabled        = dhcp6['enabled'] -%}
  {%- set dhcp6_prefix_requested  = dhcp6['prefix']['requested'] -%}

  {#--------------------------------------------------------------------
   # SLAAC options
   #------------------------------------------------------------------#}
  {#- If SLAAC is disabled, disable autoconfiguration -#}
  {%- if slaac_is_enabled is sameas false -%}
    {{
      lines.append(
        TAB ~ "post-up echo 0 > /proc/sys/net/ipv6/conf/" ~
        device ~ "/autoconf")
    }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Router advertisement options
   #------------------------------------------------------------------#}
  {%- if rtadv_is_enabled is sameas true -%}
    {%- if rtadv_is_forced is sameas true -%}
      {{ lines.append(TAB ~ "accept_ra 2") }}
    {%- elif rtadv_is_forced is sameas false -%}
      {{ lines.append(TAB ~ "accept_ra 1") }}
    {%- endif -%}
  {%- elif rtadv_is_enabled is sameas false -%}
    {{ lines.append(TAB ~ "accept_ra 0") }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Link local address autoconfiguration
   #------------------------------------------------------------------#}
  {#- Set link-local auto-configuration options -#}
  {%- if  slaac_is_enabled is not sameas false
      and ll_autoconf_is_enabled is not sameas false
  -%}
    {#- Autoconfiguration max attempts -#}
    {%- if ll_autoconf_attempts is not sameas None
       and ll_autoconf_attempts | int > 0 -%}
      {{
        lines.append(TAB ~ "ll-attempts " ~ ll_autoconf_attempts | int)
      }}
    {%- endif -%}

    {#- Autoconfiguration interval -#}
    {%- if ll_autoconf_interval is not sameas None
       and ll_autoconf_interval | float > 0 -%}
      {{
        lines.append(
          TAB ~ "ll-interval " ~ ll_autoconf_interval | float | round(2))
      }}
    {%- endif -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Privacy extensions temporary addresses
   # -------------------------------------------------------------------
   # These ones do not explicitly require SLAAC to be enabled, because
   # they may be used with stateless DHCPv6.
   #------------------------------------------------------------------#}
  {%-   if rfc4041_is_enabled is sameas true -%}
    {%- if rfc4041_is_preferred is sameas true -%}
      {{ lines.append(TAB ~ "privext 2") }}
    {%- elif rfc4041_is_preferred is sameas false -%}
      {{ lines.append(TAB ~ "privext 1") }}
    {%- endif -%}
  {%- elif rfc4041_is_enabled is sameas false -%}
    {{ lines.append(TAB ~ "privext 0") }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Stateless DHCPv6
   #------------------------------------------------------------------#}
  {%- if dhcp6_is_enabled is sameas true -%}
    {{ lines.append(TAB ~ "dhcp 1") }}
    {%- if dhcp6_prefix_requested is sameas true -%}
      {{ lines.append(TAB ~ "request_prefix 1") }}
    {%- elif dhcp6_prefix_requested is sameas false -%}
      {{ lines.append(TAB ~ "request_prefix 0") }}
    {%- endif -%}
  {%- elif dhcp6_is_enabled is sameas false -%}
    {{ lines.append(TAB ~ "dhcp 0") }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Generate stanza
   #------------------------------------------------------------------#}
  {%- if lines or slaac_is_enabled -%}
    {{ helpers.render_stanza(device, "inet6", "auto", lines, desc) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Generate dhcp stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating an 'inet6 dhcp' stanza.
 #===================================================================-#}
{%- macro generate_dhcp_stanza(interface, indexes) -%}
  {%- set TAB = "\t" -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#- Set shortcut variables -#}
  {%- set dhcp6   = interface['inet6']['dhcp'] -%}
  {%- set slaac   = interface['inet6']['slaac'] -%}

  {#- Fetch config settings -#}
  {%- set slaac_is_enabled = slaac['enabled'] -%}
  {%- set dhcp6_is_enabled = dhcp6['enabled'] -%}
  {%- set dhcp6_prefix_requested = dhcp6['prefix']['requested'] -%}

  {#--------------------------------------------------------------------
   # Prefix delegation options
   #------------------------------------------------------------------#}
  {%- if dhcp6_prefix_requested is sameas true -%}
    {{ lines.append(TAB ~ "request_prefix 1") }}
  {%- elif dhcp6_prefix_requested is sameas false -%}
    {{ lines.append(TAB ~ "request_prefix 0") }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Generate stanza
   #------------------------------------------------------------------#}
  {#- Only render stanza when stateful DHCPv6 is expected -#}
  {%- if slaac_is_enabled is not sameas true
         and dhcp6_is_enabled is sameas true -%}
    {{ helpers.render_stanza(device, "inet6", "dhcp", lines, desc) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Generate manual stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating an 'inet6 manual' stanza.
 #===================================================================-#}
{%- macro generate_manual_stanza(interface, indexes) -%}
  {%- set TAB = "\t" -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#--------------------------------------------------------------------
   # Generate stanza
   #------------------------------------------------------------------#}
  {{ helpers.render_stanza(device, "inet6", "manual", lines, desc) }}
{%- endmacro -%}

{#======================================================================
 # Generate static stanza
 #----------------------------------------------------------------------
 # This macro is responsible for generating an 'inet6 static' stanza.
 #===================================================================-#}
{%- macro generate_static_stanza(interface, indexes, alias) -%}
  {%- set TAB = "\t" -%}
  {%- set device = helpers.get_stanza_device(interface, indexes) -%}
  {%- set desc = interface['desc'] -%}
  {%- set lines = [] -%}

  {#- Set shortcut variables -#}
  {%- set dad = interface['inet6']['ndp']['dad'] -%}

  {#--------------------------------------------------------------------
   # IPv6 address and prefix netmask
   #------------------------------------------------------------------#}
  {#- Fetch config settings -#}
  {%- set alias_str = alias['address'] ~ '/' ~ alias['length'] -%}
  {%- set alias_host = alias_str | ipv6('host/prefix') -%}

  {#- Alias address -#}
  {{ lines.append(
      TAB ~ "address " ~ alias_host | ipaddr('address'))
  }}
  {#- Alias netmask -#}
  {{ lines.append(
      TAB ~ "netmask " ~ alias_host | ipaddr('prefix'))
  }}

  {#--------------------------------------------------------------------
   # Default gateway
   #------------------------------------------------------------------#}
  {%- if 'gateway' in alias and 'address' in alias['gateway'] -%}
    {#- Fetch config settings -#}
    {%- set gateway_address = alias['gateway']['address'] -%}

    {#- If scope of gateway address is link, we need to add the
     # interface device name to the gateway address -#}
    {%- if gateway_address | ipv6('fe80::/10') -%}
      {{
        lines.append(
          TAB ~ "gateway " ~ gateway_address ~
          "%" ~ config.get_interface_device_name(interface))
      }}
    {%- else -%}
      {{ lines.append(TAB ~ "gateway " ~ gateway_address) }}
    {%- endif -%}
    {%- if 'metric' in alias['gateway'] -%}
      {{
        lines.append(
          TAB ~ "metric " ~ alias['gateway']['metric'] | int)
      }}
    {%- endif -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # DAD options
   #------------------------------------------------------------------#}
  {#- Fetch config settings -#}
  {%- set dad_is_enabled = dad['enabled'] -%}
  {%- set dad_attempts   = dad['attempts'] -%}
  {%- set dad_interval   = dad['interval'] -%}

  {#- Build options -#}
  {%- if dad_is_enabled is sameas true -%}
    {%- if dad_attempts is not sameas None -%}
      {%- if dad_attempts | int > 0 -%}
        {{
          lines.append(TAB ~ "dad-attempts " ~ dad_attempts)
        }}
      {%- else -%}
        {{ lines.append(TAB ~ "dad-attempts 0") }}
      {%- endif -%}
    {%- endif -%}
    {%- if dad_interval is not sameas None -%}
      {%- if dad_interval | round(0, 'ceil') | int > 0 -%}
        {{
          lines.append(TAB ~ "dad-interval " ~ dad_interval)
        }}
      {%- endif -%}
    {%- endif -%}
  {%- elif dad_is_enabled is sameas false -%}
    {{ lines.append(TAB ~ "dad-attempts 0") }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Generate stanza
   #------------------------------------------------------------------#}
  {%- if lines -%}
    {{ helpers.render_stanza(device, "inet6", "static", lines, desc) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Generate static stanzas
 #----------------------------------------------------------------------
 # Wrapper around generate_static_stanza()
 #===================================================================-#}
{%- macro generate_static_stanzas(interface, indexes) -%}
  {%- for alias in interface['inet6']['static'] -%}
    {%- set static_stanza =
        generate_static_stanza(interface, indexes, alias) -%}
    {%- if static_stanza -%}
      {{ static_stanza ~ "\n" }}
    {%- endif -%}
  {%- endfor -%}
{%- endmacro -%}

{#======================================================================
 # Generate all inet6 stanzas
 #----------------------------------------------------------------------
 # This macro is responsible for generating zero, one or several inet6
 # stanzas for the supplied interface, depending on its configuration.
 #===================================================================-#}
{%- macro generate(interface, indexes, common_stanza) -%}

  {#- Fetch config settings -#}
  {%- set ipv6_is_enabled = interface['inet6']['enabled'] -%}

  {#- We only proceed if IPv6 is enabled on the interface -#}
  {%- if ipv6_is_enabled is sameas true -%}

    {#- Generate the 'inet6 auto' stanza -#}
    {%- set auto_stanza = generate_auto_stanza(interface, indexes) -%}
    {%- if auto_stanza -%}
      {{ auto_stanza ~ "\n" }}
    {%- endif -%}

    {#- Generate 'inet6 static' stanzas -#}
    {%- set static_stanzas =
        generate_static_stanzas(interface, indexes) -%}
    {%- if static_stanzas -%}
      {{ static_stanzas }}
    {%- endif -%}

    {#- Generate the 'inet6 dhcp' stanza -#}
    {%- set dhcp_stanza = generate_dhcp_stanza(interface, indexes) -%}
    {%- if dhcp_stanza -%}
      {{ dhcp_stanza ~ "\n" }}
    {%- endif -%}

    {#- Generate an 'inet6 manual' default stanza as a fallback -#}
    {%- if  not common_stanza
        and not auto_stanza
        and not static_stanzas
        and not dhcp_stanza
    -%}
      {%- set manual_stanza =
          generate_manual_stanza(interface, indexes) -%}
      {%- if manual_stanza -%}
        {{ manual_stanza ~ "\n" }}
      {%- endif -%}
    {%- endif -%}

  {%- endif -%}
{%- endmacro -%}
